<script>
    import MessageBox from './MessageBox.vue'

    export default {
        components: { MessageBox },
        props: {
            currentClient: Object,
            currentChat: Array,
        },
        data: () => ({
            newMessage: ''
        }), 
        methods: {
            sendMessage() {
                const date = new Date();
                this.currentChat.push({
                    message: { text: this.newMessage },
                    createdAt: date
                })

                this.newMessage = '';
                setTimeout(() => this.scrollToBottom(), 0.0001);
            },
            scrollToBottom() {
                this.$refs.bottomEl.scrollIntoView({ behavior: 'smooth' });
            },
        },  
        computed: {
            userImg(){
                if (this.currentClient.img) {
                    return this.currentClient.img
                } else  return 'chat-default'
            },
            currentChatStr(){
                return JSON.stringify(this.currentClient);
            } 
        },
        watch: { 
            currentChatStr: function(newVal, oldVal) {
                this.$refs.conversationArea.style.opacity = '0'

                setTimeout(() => {
                    this.$refs.conversationArea.style.opacity = '1'
                    this.$refs.bottomEl.scrollIntoView({ behavior: 'auto' })
                }, 100)
            }
        },
        mounted(){
            this.$refs.bottomEl.scrollIntoView({ behavior: 'auto' })
        }
    }
</script>
<template>
    <div class="chat-tray w-100pr h-100vh flex bg-l-grey flex-column justify-between pt-31 xl:pt-0">
        <!-- HEADER -->
        <div class="chat-tray-header flex align-center justify-between bg-white lg:-mx-4 py-4 px-6">
            <div class="flex align-center">
                <img class="w-6 mr-2 lg:hidden" src="@/assets/images/views/panel/icon-arrow-back.svg" alt="" @click="$emit('closeTray')">

                <div class="h-8 xl:h-12 w-8 xl:w-12 rounded-100pr bg-center bg-cover bg-no-repeat mr-3" :style="{ 'background-image': 'url('+ require('@/assets/images/views/panel/'+ userImg +'.jpg') +')'}" @click="$emit('openData')"></div>
                <h2 class="chat-item-name tx-16 mb-0" @click="$emit('openData')">
                    {{ currentClient.name }}
                </h2>
            </div>
            <span class="tx-12 tx-bold tx-green-1">
                En linea
            </span>
        </div>

        <!-- CONVERSATION AREA -->
        <div ref="conversationArea" class="conversation-area h-100pr overflow-auto py-7 px-6 lg:-mx-4">
            <message-box :data="message" v-for="(message, idx) in currentChat" :key="idx"/>
            <div ref="bottomEl"></div>
        </div>

        <!-- WRITER AREA -->
        <div class="writer-area flex align-center min-h-20 bg-white px-4 lg:-mx-4 py-4 md:px-10">
            <textarea class="h-12 w-100pr border-0 resize-none mr-5" placeholder="Escribe un mensaje" v-model="newMessage" @keyup.enter="sendMessage()"></textarea>

            <div class="flex align-center flex-none">
                <img class="cursor-pointer" src="@/assets/images/views/panel/icon-clip.svg" alt="">
                <img class="cursor-pointer mx-3 lg:mx-5" src="@/assets/images/views/panel/icon-smile.svg" alt="">

                <!-- BTN SEND -->
                <div class="btn-send-message h-13 w-13 flex-none rounded-4 bg-blue-1 grid place-items-center transition-100 cursor-pointer" @click="sendMessage()" :class="newMessage === '' && 'no-events opacity-05'">
                    <img class="-ml-2" src="@/assets/images/views/panel/icon-send.svg" alt="">
                </div>
            </div>
        </div>
    </div>
</template>